<!DOCTYPE html>
<html style="" lang="en-US">

<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>[Dicas-L] Bashes numericas no BASh</title>
<link href="modelo-3_arquivos/css_002.css" rel="stylesheet">
<link href="modelo-3_arquivos/css_003.css" rel="stylesheet" type="text/css">
<link rel="stylesheet" href="modelo-3_arquivos/responsee.css">
</head>

<body style="background:white; width:580px; margin:auto">

<h1>Bashes numéricas no BASh</h1>

<p>
<b><em>Colaboração: Paulo Roberto Bagatini</em></b>
</p>
<p>
<b><em>Data de Publicação: 19 de fevereiro de 2013</em></b>
</p>
<p>
Umas das capacidades inatas do <a href="http://linux.die.net/man/1/bash">BASh</a>,
um dos shell texto mais usados, é a manipulação de números em bases
numéricas outras que não a decimal.
</p>

<h2>Conversão de uma base qualquer para decimal</h2>

<pre class="comandos">$ echo $((844)) # decimal
<span class="saida">844 </span>

$ echo $((0x34c)) # hexadecimal
<span class="saida">844 </span>

$ echo $((01514)) # octal
<span class="saida">844 </span>

$ echo $((2#1101001100)) # binario
<span class="saida">844 </span>

$ echo $((21#1j4)) # base 21 -&gt;QUALQUER BASE!
<span class="saida">844 </span>
</pre>

<h2>Operações com números em várias bases numéricas</h2>

<pre class="comandos">$ echo $(( 2#1101001100 * 0x34c + 21#1j4)) # 844 * 844 + 844
<span class="saida">713180 </span>
</pre>

<h2>Conversão de decimal para outras bases</h2>

<p>
A conversão de decimal para outras bases não é tão "nativa".
Então, naturalmente, existem várias formas de fazer.
Aqui vão algumas sugestões, priorizando o <b>não uso</b> de loops.
</p>
<pre class="comandos">$ dec=844
$ printf '%x\n' $dec # para hexadecimal
<span class="saida">34c </span>

$ printf '%X\n' $dec
<span class="saida">34C </span>

$ printf '%o\n' $dec # para octal
<span class="saida">1514 </span>

$ bc &lt;&lt;&lt; "obase=2;$dec" # para binario
<span class="saida">1101001100 </span>

$ bc &lt;&lt;&lt; "obase=21;$dec" # para base 21 -&gt;QUALQUER BASE!
<span class="saida">01 19 04 </span>

$ # usando letras como digitos para bases maiores que 10
$ eval echo -e $(bc &lt;&lt;&lt; "obase=21;$dec" | sed -r 's/ [1-9][0-9]/\\\\x$(printf %x $((&amp;-9+96)))/g;s/ 0//g')
<span class="saida">1j4 </span>
</pre>

<h2>Conversão de uma base qualquer (ibase&lt;=16) para outra base qualquer (obase&lt;=2.147.483.647 :-p)</h2>

<pre class="comandos">$ bc &lt;&lt;&lt; "obase=16;ibase=2;1101001100"
<span class="saida">34C </span>

$ bc &lt;&lt;&lt; "ibase=2;obase=1010;11" # cuidado com a ordem das variáveis ibase e obase ;-)
<span class="saida">3 </span>
</pre>

<h2>Código ascii decimal para caracter (chr)</h2>

<pre class="comandos">$ echo -e \\x$(printf %x 65)
<span class="saida">A </span>
</pre>

<h2>Caracter para código ascii decimal (ord)</h2>

<pre class="comandos">$ echo -n A | od -td1 | grep -Eo " [0-9]+"
<span class="saida">65 </span>
</pre>

<h2>Caracter para código ascii hexadecimal no uso em URL's</h2>

<pre class="comandos">$ string='http://uma_url/~user/index.html?parm1=VAL1&amp;parm2=ã-ç'
$ echo -n "$string" | od -tx1 | grep -Eo "( ..)+$" | tr " a-z" "%A-Z" | tr -d "\n"; echo
<span class="saida">%68%74%74%70%3A%2F%2F%75%6D%61%5F%75%72%6C%2F%7E%75%73%65%72%2F%69%6E%64%65%78%2E%68%74%6D%6C%3F%70%61%72%6D%31%3D%56%41%4C%31%26%70%61%72%6D%32%3D%C3%A3%2D%C3%A7</span>
</pre>

<h2>Caracter especiais (diferentes de [a-zA-Z0-9-._~-]) para código ascii hexadecimal no uso em URL's</h2>

<pre class="comandos">$ eval echo $(sed -r 's/[^A-Za-z0-9._~-]/$(echo -n "\\&amp;" | od -tx1 | grep -Eo "( ..)+$" | tr " a-z" "%A-Z")/g;s/\\([^\\"])/\1/g' &lt;&lt;&lt; $string)
<span class="saida">http%3A%2F%2Fuma_url%2F~user%2Findex.html%3Fparm1%3DVAL1%26parm2%3D%C3%A3-%C3%A7</span>
</pre>

<h2>Cuidado com ambientes com suporte a Unicode</h2>

<pre class="comandos">$ echo -n A | od -tx1 | grep -Eo " ..+"
<span class="saida">41 </span>

$ echo -n Ç | od -tx1 | grep -Eo " ..+"
<span class="saida">c3 87 </span>

$ echo -n Ç | iconv -f utf8 -t latin1 | od -tx1 | grep -Eo " ..+"
<span class="saida">c7 </span>

$ echo $((0xc7))
<span class="saida">199 </span>
</pre>

<h2>Comandos usados nesse artigo</h2>

<ul>
<li><a href="http://linux.die.net/man/1/bash">bash</a>
</li><li><a href="http://linux.die.net/man/1/bc">bc</a>
</li><li><a href="http://linux.die.net/man/1/echo">echo</a>
</li><li><a href="http://linux.die.net/man/1/eval">eval</a>
</li><li><a href="http://linux.die.net/man/1/grep">grep</a>
</li><li><a href="http://linux.die.net/man/1/iconv">iconv</a>
</li><li><a href="http://linux.die.net/man/1/od">od</a>
</li><li><a href="http://linux.die.net/man/1/printf">printf</a>
</li><li><a href="http://linux.die.net/man/1/sed">sed</a>
</li><li><a href="http://linux.die.net/man/1/tr">tr</a>
</li></ul>

</html>
